unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, OmegaInput, Unit2, 
  OmegaScreen, OmegaTimer, OmegaImageList, OmegaUtils, {$I UseD3D8.inc};

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    list1: TListBox;
    list2: TListBox;
    list3: TListBox;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Button1: TButton;
    OmegaInput1: TOmegaInput;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    OmegaScreen1: TOmegaScreen;
    OmegaTimer1: TOmegaTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure list1Click(Sender: TObject);
    procedure list2Click(Sender: TObject);
    procedure list3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure OmegaTimer1Timer(Sender: TObject);
  end;

var
  Form1: TForm1;
  Form2: TForm2;
  cur_ad, cur_dev:integer;
  
implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var b,i:integer;
    s:string;
begin
 Form2 := TForm2.Create(nil);
 cur_ad:=0;
 cur_dev:=0;
 OmegaScreen1.SetHWnd(form2.handle);
 OmegaScreen1.BuildDeviceList;
 list1.clear;
 list2.clear;
 list3.clear;
 for i := 0 to OmegaScreen1.NumAdapters - 1 do
  list1.Items.add(OmegaScreen1.Adapters[i].AdapterIdentifier.Description);
 for i := 0 to OmegaScreen1.Adapters[0].NumDevices - 1 do
  list2.items.add(OmegaScreen1.Adapters[0].devices[i].strDesc);
 for i := 0 to OmegaScreen1.Adapters[0].devices[0].NumModes - 1 do
 with OmegaScreen1.Adapters[0].devices[0].modes[i] do
 begin
  b := 16;
  if (Format = D3DFMT_X8R8G8B8) or
     (Format = D3DFMT_A8R8G8B8) or
     (Format = D3DFMT_R8G8B8) then b := 32;
  s:=inttostr(width)+'x'+inttostr(height)+'x'+inttostr(b);
  list3.items.add(s);
 end;
 list1.ItemIndex:=0;
 list2.ItemIndex:=0;
 list3.ItemIndex:=0;
 list1click(sender);
 list2click(sender);
 list3click(sender);
 OmegaScreen1.Init;
// OmegaTimer1.enabled:=true;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 form2.free;
end;

procedure TForm1.list1Click(Sender: TObject);
var b,i:integer;
    s:string;
begin
 cur_ad:=list1.itemindex;
 cur_dev:=0;
 list2.clear;
 list3.clear;
 for i := 0 to OmegaScreen1.Adapters[cur_ad].NumDevices - 1 do
  list2.items.add(OmegaScreen1.Adapters[cur_ad].devices[i].strDesc);
 for i := 0 to OmegaScreen1.Adapters[cur_ad].devices[0].NumModes - 1 do
 with OmegaScreen1.Adapters[cur_ad].devices[0].modes[i] do
 begin
  b := 16;
  if (Format = D3DFMT_X8R8G8B8) or
     (Format = D3DFMT_A8R8G8B8) or
     (Format = D3DFMT_R8G8B8) then b := 32;
  s:=inttostr(width)+'x'+inttostr(height)+'x'+inttostr(b);
  list3.items.add(s);
 end;
 list2.ItemIndex:=0;
 list3.ItemIndex:=0;
 with OmegaScreen1.Adapters[cur_ad].AdapterIdentifier do
 begin
  b := 16;
  if (OmegaScreen1.Adapters[cur_ad].Desktop.Format = D3DFMT_X8R8G8B8) or
     (OmegaScreen1.Adapters[cur_ad].Desktop.Format = D3DFMT_A8R8G8B8) or
     (OmegaScreen1.Adapters[cur_ad].Desktop.Format = D3DFMT_R8G8B8) then b := 32;
 label4.caption:='Adapter Information:'#10#13+
 'Name: '+Description+#10#13+
 'Driver: '+Driver+#10#13+
 'Version: '+inttostr(DriverVersion)+#10#13+
 'VendorID: '+inttostr(VendorId)+#10#13+
 'DeviceID: '+inttostr(DeviceId)+#10#13+
 'SubsysID: '+inttostr(SubsysId)+#10#13+
 'Revision: '+inttostr(Revision)+#10#13+
 'WHQLLevel: '+inttostr(WHQLLevel)+#10#13+
 'Number of Devices: '+inttostr(OmegaScreen1.Adapters[cur_ad].NumDevices)+#10#13#13+
 'Desktop Resolution: '+inttostr(OmegaScreen1.Adapters[cur_ad].Desktop.Width)+'x'+
 inttostr(OmegaScreen1.Adapters[cur_ad].Desktop.Height)+#10#13+
 'Desktop Refresh Rate: '+inttostr(OmegaScreen1.Adapters[cur_ad].Desktop.RefreshRate)+#10#13+
 'Desktop Format: '+inttostr(cardinal(OmegaScreen1.Adapters[cur_ad].Desktop.Format))+' ('+
 inttostr(b)+' bit)';
 end;
 list2click(sender);
 list3click(sender);
end;

function btostr(b:boolean): string;
begin
 if b then result := 'true' else result := 'false';
end;

procedure TForm1.list2Click(Sender: TObject);
var b,i:integer;
    s:string;
begin
 cur_dev:=list2.itemindex;
 list3.clear;
 for i := 0 to OmegaScreen1.Adapters[cur_ad].devices[cur_dev].NumModes - 1 do
 with OmegaScreen1.Adapters[cur_ad].devices[cur_dev].modes[i] do
 begin
  b := 16;
  if (Format = D3DFMT_X8R8G8B8) or
     (Format = D3DFMT_A8R8G8B8) or
     (Format = D3DFMT_R8G8B8) then b := 32;
  s:=inttostr(width)+'x'+inttostr(height)+'x'+inttostr(b);
  list3.items.add(s);
 end;
 list3.ItemIndex:=0;
 with OmegaScreen1.Adapters[cur_ad].devices[cur_dev] do
 label5.caption:='Device Information:'+#10#13+
 'DeviceType: '+inttostr(cardinal(DeviceType))+#10#13+
 'DeviceName: '+strdesc+#10#13+
 'Number of Modes: '+inttostr(NumModes)+#10#13+
 'canDoWindowed: '+btostr(canDoWindowed);
 with OmegaScreen1.Adapters[cur_ad].devices[cur_dev].Caps do
 label5.caption:=label5.caption+#10#13#13+
  'MaxTextureSize: '+inttostr(MaxTextureWidth)+'x'+inttostr(MaxTextureHeight)+#10#13+
  'MaxTextureBlendStages: '+inttostr(MaxTextureBlendStages)+#10#13+
  'MaxSimultaneousTextures: '+inttostr(MaxSimultaneousTextures)+#10#13+
  'MaxActiveLights: '+inttostr(MaxActiveLights)+#10#13+
  'MaxPrimitiveCount: '+inttostr(MaxPrimitiveCount)+#10#13+
  'MaxVertexIndex: '+inttostr(MaxVertexIndex)+#10#13+
  'MaxStreams: '+inttostr(MaxStreams)+#10#13+
  'VertexShaderVersion: '+inttostr(VertexShaderVersion)+#10#13+
  'PixelShaderVersion: '+inttostr(PixelShaderVersion)+#10#13;
 list3click(sender);
end;

procedure TForm1.list3Click(Sender: TObject);
var b:integer;
    s:string;
begin
 with OmegaScreen1.Adapters[cur_ad].devices[cur_dev].modes[list3.itemindex] do
 begin
  s:='';
  if ((Behavior and D3DCREATE_HARDWARE_VERTEXPROCESSING) = D3DCREATE_HARDWARE_VERTEXPROCESSING) and
     ((Behavior and D3DCREATE_PUREDEVICE) = D3DCREATE_PUREDEVICE) then
  begin
   if (OmegaScreen1.Adapters[cur_ad].devices[cur_dev].DeviceType = D3DDEVTYPE_HAL) then
    s := 'Pure HW'
   else
    s := 'Simulated Pure HW';
  end
  else if (Behavior and D3DCREATE_HARDWARE_VERTEXPROCESSING) = D3DCREATE_HARDWARE_VERTEXPROCESSING then
  begin
   if (OmegaScreen1.Adapters[cur_ad].devices[cur_dev].DeviceType = D3DDEVTYPE_HAL) then
    s := 'HW'
   else
    s := 'Simulated HW';
  end
  else if (Behavior and D3DCREATE_MIXED_VERTEXPROCESSING) = D3DCREATE_MIXED_VERTEXPROCESSING then
  begin
   if (OmegaScreen1.Adapters[cur_ad].devices[cur_dev].DeviceType = D3DDEVTYPE_HAL) then
    s := 'Mixed'
   else
    s := 'Simulated Mixed';
  end
  else if (Behavior and D3DCREATE_SOFTWARE_VERTEXPROCESSING) = D3DCREATE_SOFTWARE_VERTEXPROCESSING then
  begin
   s := 'SW';
  end;
  if (OmegaScreen1.Adapters[cur_ad].devices[cur_dev].DeviceType = D3DDEVTYPE_HAL) then
  begin
   s := 'Driver';
  end;
  b := 16;
  if (Format = D3DFMT_X8R8G8B8) or
     (Format = D3DFMT_A8R8G8B8) or
     (Format = D3DFMT_R8G8B8) then b := 32;
  label6.caption:='Mode Information:'#10#13+
 'Width: '+inttostr(Width)+#10#13+
 'Height: '+inttostr(Height)+#10#13+
 'Format: '+inttostr(cardinal(Format))+' ('+inttostr(b)+' bit)'+#10#13+
 'Depth Stencil Format: '+inttostr(cardinal(DepthStencilFormat))+#10#13+
 'Behaviour: '+inttostr(behavior)+#10#13+
 'Vertex Processing: '+s;
 end;
 OmegaScreen1.Adapters[cur_ad].devices[cur_dev].CurrentMode:=list3.itemindex;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 OmegaScreen1.Width := OmegaScreen1.Adapters[cur_ad].devices[cur_dev].modes[list3.itemindex].Width;
 form2.ClientWidth := OmegaScreen1.Width;
 OmegaScreen1.Height := OmegaScreen1.Adapters[cur_ad].devices[cur_dev].modes[list3.itemindex].Height;
 form2.ClientHeight := OmegaScreen1.Height;
 OmegaScreen1.FullScreen := not checkbox1.checked;
 form2.show;
 OmegaScreen1.ShowMouseCursor := checkbox2.checked;
 OmegaScreen1.Init;
 OmegaInput1.Initialize;
 OmegaTimer1.enabled:=true;
end;

procedure TForm1.OmegaTimer1Timer(Sender: TObject);
var d1:integer;
    rect:trect;
begin
 OmegaInput1.update;
 if not OmegaScreen1.CanDraw then exit;

 if oisbutton1 in OmegaInput1.keyboard.StatesClicked then
  OmegaScreen1.ToggleFullscreen;
 if oisbutton2 in OmegaInput1.keyboard.StatesClicked then
  OmegaScreen1.ScreenShot('screen.bmp');
 OmegaScreen1.BeginRender;
 OmegaScreen1.Device.Clear(0, nil, D3DCLEAR_TARGET, 0, 1.0, 0);
 for d1 := 0 to 500 do
 begin
  Rect.Left := random(OmegaScreen1.BackBufferDesc.Width);
  Rect.Right := rect.left + random(OmegaScreen1.BackBufferDesc.Width) div 2;
  Rect.Top := random(OmegaScreen1.BackBufferDesc.Height);
  Rect.Bottom := rect.top + random(OmegaScreen1.BackBufferDesc.Height) div 2;
  OmegaScreen1.Device.Clear(1, @rect, D3DCLEAR_TARGET,
   D3DCOLOR_RGBA(random(256), random(256), random(256), 255), 1, 0);
 end;
 OmegaScreen1.EndRender;
end;

end.


