unit Module;

interface

uses
  SysUtils, Forms, Classes, OmegaImageList, OmegaTimer, OmegaFont, OmegaSprite,
  OmegaScreen;

type
  TModule1 = class(TDataModule)
    OmegaSprite1: TOmegaSprite;
    OmegaFont1: TOmegaFont;
    OmegaImageList1: TOmegaImageList;
    procedure DataModuleCreate(Sender: TObject);
  private
    { Private declarations }
  public
    CanRender : Boolean;
    TileWidth, TileHeight : integer;
    CurrentTile : integer;
    SpritesCreated : boolean;
    DrawLayer1,DrawLayer2,DrawLayer3,DrawCollision,DrawTrigger : boolean;
    CurrentLayer : integer;
    CurrentMode : string;
    Scale : real;
    CurrentEditTileX : integer;
    CurrentEditTileY : integer;
    Red,Green,Blue,Alpha : integer;
    Rotation,AnimSpeed,AnimCount : integer;
    AnimateTile : boolean;
    OriginalTile : integer;

    procedure UpdateImage(FileName : TFileName);
  end;

var
  Module1: TModule1;

implementation

{$R *.dfm}

procedure TModule1.UpdateImage(FileName:TFileName);
begin
  OmegaImageList1.ImageList.Items[0].Picture.LoadFromFile(FileName);
  OmegaImageList1.ImageList.Items[0].Transparent := True;
  OmegaImageList1.ImageList.Items[0].TileHeight := TileHeight;
  OmegaImageList1.ImageList.Items[0].TileWidth := TileWidth;
//  OmegaImageList1.Init;
end;

procedure TModule1.DataModuleCreate(Sender: TObject);
begin
  TileHeight := 32;
  TileWidth := 32;
  CurrentLayer := 1;
  DrawLayer1 := True;
  DrawLayer2 := True;
  DrawLayer3 := True;
  DrawCollision := True;
  DrawTrigger := True;
  CurrentMode := 'drawtile';
  Scale := 1;
end;

end.
