unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, OmegaSprite, OmegaSound3D, OmegaMusic, OmegaTimer, OmegaFont,
  OmegaImageList, OmegaScreen, OmegaMap, Menus, pngimage, OmegaInput,
  StdCtrls, ExtCtrls;

type
  TPlayer = class(TSimpleAnimSprite)   // our player sprite
  public
   // procedure OnCollision(Sprite:TSprite); override;
end;

type
  TForm1 = class(TForm)
    OmegaScreen1: TOmegaScreen;
    OmegaImageList1: TOmegaImageList;
    OmegaFont1: TOmegaFont;
    OmegaSprite1: TOmegaSprite;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    LoadMap1: TMenuItem;
    Exit1: TMenuItem;
    OpenDialog1: TOpenDialog;
    OmegaMap1: TOmegaMap;
    OmegaInput1: TOmegaInput;
    OmegaTimer1: TOmegaTimer;
    MapSize1: TMenuItem;
    N1screen1: TMenuItem;
    N1Screen2: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure OmegaTimer1Timer(Sender: TObject);
    procedure LoadMap1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure N1screen1Click(Sender: TObject);
    procedure N1Screen2Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Player : TPlayer;                  // our player sprite
  rot : single;                     // rotation variable for our electric thing
  Keys: array[0..255] of Boolean;    // our array to see what keys were pressed
  isloaded : boolean;
  Direction : string;
  
implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  OmegaScreen1.SethWnd(Form1.Handle);               // this is set to let the graphics know where to render to. Any component with a handle property can be rendered to
  OmegaScreen1.Init;                                // MUST be called before doing pretty much anything else :)  This initializes all graphics
  OmegaImageList1.Init;                             // must be called before you do anything with any images
  OmegaFont1.CreateFont('verdana',10,[]);           // creates our font to be used in our game
  OmegaFont1.Color := OmegaColor(255,255,255,255);  // Sets the font color
  OmegaInput1.Initialize;                          // Must be called before using our music component
  Player := TPlayer.Create(OmegaSprite1);                        // create our player from our TPlayer class
  With Player Do
    begin
      ScaleX := 0.8;
      ScaleY := 0.8;
      X := 400;                                                   // Our player's X position
      Y := 300;                                                   // Our Player's Y position
      Width := OmegaImageList1.ImageList.Items[0].ImageWidth;    // Sets our players width to the width of the image we are going to use
      Height := OmegaImageList1.ImageList.Items[0].ImageHeight;  // Sets our players height to the height of the image we are going to use
      Image := OmegaImageList1.ImageList.Items[0];               // sets our players image to the image in our imagelist
      ImageIndex := 4;
      DoCollision := True;
      AnimCount := 2;                                        // Sets the imageindex to -1 which means we want to use our entire image
      AnimSpeed := 10;
      DoAnimate := True;
    end;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  OmegaTimer1.Enabled := True;                                    // enable our omegaTimer
end;

procedure TForm1.OmegaTimer1Timer(Sender: TObject);
var a,b : integer;
begin
//---------------------------------------------------------------------------//
//                       Player Movement                                     //
//---------------------------------------------------------------------------//
  if isloaded = false then exit;

  OmegaInput1.Update;

  if oisLeft in OmegaInput1.Keyboard.States then
    begin
      if Direction <> 'left' then
        begin
          Player.ImageIndex := 6;
          Direction := 'left';
        end;
        OmegaMap1.MoveRight(5);
    end;
  if oisRight in OmegaInput1.Keyboard.States then
    begin
      if Direction <> 'right' then
        begin
          Player.ImageIndex := 2;
          Direction := 'right';
        end;
      OmegaMap1.MoveLeft(5);
    end;
  if oisUp in OmegaInput1.Keyboard.States then
    begin
      if Direction <> 'up' then
        begin
          Player.ImageIndex := 0;
          Direction := 'up';
        end;
      OmegaMap1.MoveDown(5);
    end;
  if oisDown in OmegaInput1.Keyboard.States then
    begin
      if Direction <> 'down' then
        begin
          Player.ImageIndex := 4;
          Direction := 'down';
        end;
      OmegaMap1.MoveUp(5);
    end;

//---------------------------------------------------------------------------//
//                      Draw Graphics                                        //
//---------------------------------------------------------------------------//

  OmegaScreen1.ClearScreen(0,0,0,0);    // clear the screen
  OmegaScreen1.BeginRender;             // MUST be called before drawing
  OmegaImageList1.BeginDraw;            // Must be called before drawing with imagelist

  OmegaMap1.DrawLayer1;

  OmegaMap1.DrawLayer2;

  Player.Draw;  // draws our player

  OmegaMap1.DrawLayer3;

  OmegaFont1.Print(10,10,IntToStr(round(OmegaTimer1.FPS)));  // prints text onto the screen

  //OmegaMap1.Layer1Collision(Player);

  OmegaImageList1.EndDraw;    // finishes rendering procedure
  OmegaScreen1.EndRender;     // finishes rendering procedure - MUST be called for anything to show on screen
end;

procedure TForm1.LoadMap1Click(Sender: TObject);
var a , b : integer;
begin
  if OpenDialog1.Execute then
    begin
      OmegaMap1.LoadMap(OpenDialog1.filename);
      isLoaded := true;
      OmegaTimer1.Enabled := True;
      Player.X := Form1.ClientWidth div 2;
      Player.Y := Form1.ClientHeight div 2;
      OmegaMap1.WorldX := 0;
      OmegaMap1.WorldY := 0;
      { for a := 0 to OmegaMap1.WidthCount - 1 do
        for b := 0 to OmegaMap1.HeightCount - 1 do
          begin
            if OmegaMap1.Layer1[a,b].ImageIndex = 1 then
              begin
                OmegaMap1.Layer1[a,b].DoCollision := True;
              end;
          end;    }
    end;
end;

{Procedure TPlayer.OnCollision(Sprite:TSprite);
begin

end;}


procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  OmegaTimer1.Enabled := False;
end;

procedure TForm1.N1screen1Click(Sender: TObject);
begin
  OmegaMap1.DrawScreenOnly := False;
  N1Screen1.Caption := ' * < 1 Screen ';
  N1Screen2.Caption := ' > 1 Screen ';
end;

procedure TForm1.N1Screen2Click(Sender: TObject);
begin
  OmegaMap1.DrawScreenOnly := True;
  N1Screen2.Caption := ' * > 1 Screen ';
  N1Screen1.Caption := ' < 1 Screen ';
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
 close;
end;

end.
