unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, OmegaImageList, OmegaScreen, OmegaTimer,
  OmegaBitmapFont, OmegaSprite, OmegaUtils, OmegaInput, {$I UseD3D8.inc};

type
  TFixArrow = class(TSprite)
  public
    constructor Create(const AParent: TOmegaSprite); override;
    procedure OnCollision(const Sprite: TSprite; const X, Y: integer); override;
  end;
  TMoveArrow = class(TSprite)
  public
    constructor Create(const AParent: TOmegaSprite); override;
    procedure OnCollision(const Sprite: TSprite; const X, Y: integer); override;
  end;

  TForm1 = class(TForm)        //to hold last frame time
    OmegaScreen1: TOmegaScreen;
    OmegaImageList1: TOmegaImageList;
    OmegaTimer1: TOmegaTimer;
    OmegaBitmapFont1: TOmegaBitmapFont;
    OmegaInput1: TOmegaInput;
    OmegaSprite1: TOmegaSprite;
    procedure FormCreate(Sender: TObject);
    procedure OmegaTimer1Timer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
   a1: TFixArrow;
   a2: TMoveArrow;
   hor, ver, showgrid, showborder: boolean;
  end;

var Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var i: integer;
begin
 self.ClientWidth := 800;
 self.ClientHeight := 600;
 OmegaScreen1.Width := self.ClientWidth;
 OmegaScreen1.Height := self.ClientHeight;
 OmegaScreen1.Init;
 a1 := TFixArrow.Create(OmegaSprite1);
 a2 := TMoveArrow.Create(OmegaSprite1);
 OmegaTimer1.Enabled := True;
 hor := false;
 ver := false;
 showborder := true;
 showgrid := true;
end;

constructor TFixArrow.Create(const AParent: TOmegaSprite);
begin
 inherited Create(AParent);
 Image := Form1.OmegaImageList1.ImageList.Find('Arrow');
 ImageIndex := 0;
 DoCollision := true;      //we want Collision check for this Sprite
 DoPixelcheck := true;       //we also want Pixelcheck, because its nice ;)
 X := 100;                 //Setting Position of the Sprite
 Y := 100;
 Width := 60;
 Height := 130;
end;

procedure TFixArrow.OnCollision(const Sprite: TSprite; const X, Y: integer);
begin
 if (Sprite is TMoveArrow) then
 begin
  Alpha := 100;
  Image.Renderer.OmegaScreen.SetPixel(
   round(self.x) + x, round(self.y) + y,
   255, 255, 255);
 end;
end;

constructor TMoveArrow.Create(const AParent: TOmegaSprite);
begin
 inherited Create(AParent);
 Image := Form1.OmegaImageList1.ImageList.Find('Arrow');
 ImageIndex := 0;
 DoCollision := true;
 DoPixelcheck := true;
 X := 100;
 Y := 100;
 Width := 60;
 Height := 130;
end;

procedure TMoveArrow.OnCollision(const Sprite: TSprite; const X, Y: integer);
begin
 if Sprite is TFixArrow then
 begin
  Alpha := 100;
  Sprite.Alpha := 100;
  Image.Renderer.OmegaScreen.SetPixel(
   round(self.x) + x, round(self.y) + y,
   255, 255, 255);
 end;
end;

procedure TForm1.OmegaTimer1Timer(Sender: TObject);
var p: TPoint;
begin
 if not OmegaScreen1.CanDraw then exit;

 OmegaInput1.Update;

 if oisbutton1 in OmegaInput1.keyboard.statesclicked then
  OmegaScreen1.ToggleFullScreen;

 OmegaScreen1.ClearScreen(50, 0, 0, 0);
 OmegaScreen1.BeginRender;
 a1.Alpha := 255;
 a2.Alpha := 255;

 if not OmegaScreen1.FullScreen then
 begin
  p := ScreenToClient(Mouse.CursorPos);
  a2.x := p.x - 30;
  a2.y := p.Y - 65;
 end else
 begin
  a2.x := Mouse.CursorPos.X - 30;
  a2.y := Mouse.CursorPos.Y - 65;
 end;

 a2.MirrorHorizontally := hor;
 a2.MirrorVertically := ver;

 if showgrid then
 begin
  OmegaScreen1.DrawRectangle(99,164,160,164,false,1,70,0,0);
  OmegaScreen1.DrawRectangle(129,99,129,230,false,1,70,0,0);
  OmegaScreen1.DrawRectangle(round(a2.x-1),round(a2.y+64),
   round(a2.x+60),round(a2.y+64),false,1,70,0,0);
  OmegaScreen1.DrawRectangle(round(a2.x+29),round(a2.y-1),
   round(a2.x+29),round(a2.y+130),false,1,70,0,0);
 end;

 if showborder then
 begin
  OmegaScreen1.DrawRectangle(99,99,160,230,false,1,255,0,0);
  OmegaScreen1.DrawRectangle(round(a2.x-1),round(a2.y-1),
   round(a2.x+60),round(a2.y+130),false,1,255,0,0);
 end;

 OmegaSprite1.Collision;                 //Check for any Collisions;
 OmegaSprite1.Draw;                      //Draw our Sprites

 OmegaBitmapFont1.Print(40, 400, 'Press "H" to toggle horizontal mirroring');
 OmegaBitmapFont1.Print(40, 430, 'Press "V" to toggle vertical mirroring');
 OmegaBitmapFont1.Print(40, 460, 'Press "B" to toggle border display');
 OmegaBitmapFont1.Print(40, 490, 'Press "G" to toggle grid display');
 OmegaBitmapFont1.Print(40, 520, 'Press "space" to toggle fullscreen');

 OmegaScreen1.EndRender;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 OmegaTimer1.Enabled := False;
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var i,x,y:integer;
begin
 if key = 27 then close;
 if key = ord('B') then showborder:=not showborder;
 if key = ord('G') then showgrid:=not showgrid;
 if key = ord('H') then hor := not hor;
 if key = ord('V') then ver := not ver;
end;

end.



