unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, OmegaImageList, OmegaScreen, OmegaTimer,
  OmegaBitmapFont, OmegaSprite, OmegaFlexiGrid,
  OmegaUtils, OmegaRenderer;

type
  TForm1 = class(TForm)
    OmegaScreen1: TOmegaScreen;
    OmegaImageList1: TOmegaImageList;
    OmegaTimer1: TOmegaTimer;
    OmegaBitmapFont1: TOmegaBitmapFont;
    fl: TOmegaFlexiGrid;
    procedure FormCreate(Sender: TObject);
    procedure OmegaTimer1Timer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormDestroy(Sender: TObject);
    procedure OmegaScreen1Init(Sender: TObject);
  end;

var Form1: TForm1;
    sc1, sc2, sc3, sc4, angle, ang: single;
    bm, ii:integer;
implementation


{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
 sc1:=1;sc2:=1;ii:=0;
 randomize;
 self.ClientWidth := 512;
 self.ClientHeight := 512;
 OmegaScreen1.Width := self.ClientWidth;
 OmegaScreen1.Height := self.ClientHeight;
 OmegaScreen1.Init;
 OmegaTimer1.Enabled := True;
end;

procedure TForm1.OmegaTimer1Timer(Sender: TObject);
var s: single; // temporary variable
begin
 if not omegascreen1.CanDraw then exit;
 OmegaScreen1.BeginRender;

 OmegaScreen1.ClearScreen(0,0,0,0);

 angle := angle + 0.6;
 if angle >= 360 then angle := angle - 360;
 OmegaScreen1.SetAntiAliasing(true);
 s := sin(angle * pi / 180);
 fl.scalex:=sc3+0.5*(s+1)*sc1;
 fl.scaley:=sc4+0.5*(s+1)*sc2;
 fl.rotation:=fl.rotation+ang;
 // draw background
 if ii = 1 then
 begin
  omegaimagelist1.ImageList.items[1].draw(0,0,0,0,0,2,2,
   OmegaColor($FFFFFFFF),-1,bm);
  fl.imageindex:=0;
 end else
 begin
  omegaimagelist1.ImageList.items[0].draw(0,0,0,0,0,4,4,
   OmegaColor($FFFFFFFF),-1,bm);
  fl.imageindex:=1;
 end;

 fl.draw(0,0,512,512);

 OmegaBitmapFont1.Print(60, 320, 'Press "S" to swap sprites');
 OmegaBitmapFont1.Print(60, 340, 'Press "B" to randomize blendmode');
 OmegaBitmapFont1.Print(60, 360, 'Press "C" to randomize color');
 OmegaBitmapFont1.Print(60, 380, 'Press "M" to randomize movement');
 OmegaBitmapFont1.Print(60, 400, 'Press "R" to randomize all');
 OmegaBitmapFont1.Print(60, 420, 'Press "Space" to toggle fullscreen');

 OmegaScreen1.EndRender;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 OmegaTimer1.Enabled := False;
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if key = 27 then close;
 if key = 32 then OmegaScreen1.ToggleFullScreen;
 if key = ord('S') then ii:=1-ii;
 if (key = ord('C'))or(key = ord('R')) then
 begin
 if random<0.5 then
 begin
 fl.ColorTL:=OmegaColor(128+random(128),128+random(128),128+random(128),random(256));
 fl.ColorBL:=OmegaColor(128+random(128),128+random(128),128+random(128),random(256));
 fl.ColorTR:=OmegaColor(128+random(128),128+random(128),128+random(128),random(256));
 fl.ColorBR:=OmegaColor(128+random(128),128+random(128),128+random(128),255);
 end else
 fl.Color:=OmegaColor(128+random(128),128+random(128),128+random(128),random(256));
 end;
 if (key = ord('B'))or(key = ord('R')) then bm:=random(5);
 if (key = ord('M'))or(key = ord('R')) then
 begin
 fl.NumberOfColumns := random(10)+1;
 fl.NumberOfRows := random(10)+1;
 sc1:=random*2;
 sc2:=random*2;
 sc3:=random;
 sc4:=random;
 sc1:=1;
 sc2:=1;
 sc3:=0;
 sc4:=0;
 fl.rotationcenterx:=random*2;
 fl.rotationcentery:=random*2;
 fl.scaletexture:=random>0.5;
 fl.rotation:=0;
 ang:=random*4;
 if ang>2 then ang:=2;
 ang:=ang-2;
 end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 fl.free;
end;

procedure TForm1.OmegaScreen1Init(Sender: TObject);
begin
 with fl do
 begin
 NumberOfColumns := 8;
 NumberOfRows := 8;
 ScaleX:=0.5;
 ScaleY:=0.5;
 sc3:=0;sc4:=0;
 rotationcenterx:=0;
 rotationcentery:=0;
 rotation:=0;
 ScaleTexture:=not true;
 OmegaScreen := OmegaScreen1;
 OmegaImageList := OmegaImageList1;
 imageindex := 0;
 end;
 ColorToAlpha(omegaimagelist1.imagelist.items[0].image,1,0,0,0);
end;

end.
