//****************************************************************
// SAMPLE for
// OmegaGUI component (2003)
// Made by Patroclus
// as part of Omega Components
//(04/06/03)
//****************************************************************
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics,
  Controls, Forms, Dialogs, OmegaGUI, OmegaTimer, OmegaFont,
  OmegaImageList, OmegaScreen, StdCtrls, OmegaSprite, JPEG,
  OmegaBitmapFont;

type
  TForm1 = class(TForm)
    OmegaScreen: TOmegaScreen;
    ImageList: TOmegaImageList;
    Timer: TOmegaTimer;
    OmegaGUI: TOmegaGUI;
    Font1: TOmegaBitmapFont;
    Font2: TOmegaBitmapFont;
    procedure TimerTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender:TObject);
    procedure Button5Click(Sender:TObject);
    procedure RadioButtonClick(Sender:TObject);
    procedure CheckButtonClick(Sender:TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


var
  Form1: TForm1;
  ButtonList: TOmegaGUIList;                    //ok, we declare a component list
  OthersList: TOmegaGUIList;                    //we declare another list
  PanelList: TOmegaGUIPanel;
  ButtonO : array [0..4] of TOmegaButton;       //array for 4 buttons
  EditO: TOmegaEdit;                            //and Edit component
  TextO: TOmegaText;                            //an output memo component
  ListO: TOmegaList;                            //and a listbox
  PBarO: TOmegaBar;
  PScrollO: TOmegaScrollBar;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var i:Integer;
    x,y: Integer;
begin
  Omegascreen.SethWnd(Self.Handle);             //we all know
  OmegaScreen.Init;
  ImageList.Init;
  Timer.Enabled:=True;
  font1.MakeFont('Arial', DEFCHARACTERS, 8, 0);
  ButtonList:=TOmegaGUIList.Create(OmegaGUI);   //we create a one of the list
  ButtonList.Name:='ButtonList';
  x:=10; y:=10;
  For i:=0 to 4 do                              //and add the 4 buttons
  begin
    ButtonO[i]:=TOmegaButton.Create(ButtonList);
    ButtonO[i].Image[0]:=ImageList.ImageList.Items[0];  //default image
    ButtonO[i].ImageIndex[0]:=0;
    ButtonO[i].Image[1]:=ImageList.ImageList.Items[1];  //when mousse is over
    ButtonO[i].ImageIndex[1]:=0;
    ButtonO[i].Image[2]:=ImageList.ImageList.Items[2];  //when mouse is clicking
    ButtonO[i].ImageIndex[2]:=0;
    ButtonO[i].Image[3]:=ImageList.ImageList.Items[3];  //when it's active
    ButtonO[i].ImageIndex[3]:=0;
    ButtonO[i].Width:=100;
    ButtonO[i].Height:=50;
    ButtonO[i].X:=x;
    ButtonO[i].Y:=y;
    y:=y+60;
  end;
  ButtonO[4].Y:=ButtonO[3].Y+55;        //let's make button4 step over button3
  ButtonO[0].Caption:='Button';           //we set the caption of buttons
  ButtonO[1].Caption:='CheckButton';
  ButtonO[1].Checkeable:=True;            //and this one if checkButton

  For i:=2 to 3 do                        //the other two are the same
  begin
    ButtonO[i].Checkeable:=True;          //checkbuttons
    ButtonO[i].Group:=0;                  //but both in group 0
                                          //this means that only one button
                                          //in group 0 can be active at a time
                                          //so it is like radiobuttons
                                          //there can be as many groups as needed
    ButtonO[i].Caption:='RadioBtn';      //set caption
    ButtonO[i].Centered:=False;           //do not center caption, align left
  end;

  OthersList:=TOmegaGUIList.Create(OmegaGUI);   //create the other list
  OthersList.Name:='Others';

  EditO:=TOmegaEdit.Create(OthersList);         //and add the Edit
  EditO.Image[0]:=ImageList.ImageList.Items[4]; //set default image
  EditO.ImageIndex[0]:=0;
  EditO.Image[1]:=ImageList.ImageList.Items[4]; //set mouse-over image
  EditO.ImageIndex[1]:=1;
  EditO.Image[3]:=ImageList.ImageList.Items[5]; //set focussed image
  EditO.ImageIndex[3]:=0;
  EditO.Anim[3]:=True;                          //but this one animated
  EditO.AnimSpeed[3]:=100;
  EditO.AnimCount[3]:=3;
  EditO.X:=200;
  EditO.Y:=20;
  EditO.Height:=30;
  EditO.Width:=200;
  EditO.Text:='Click here and edit';
  //property InputChar can be Normal, UpperCase, LowerCase or numeric
  //it will restring any keyboard input to match the selected option
  //property LinePattern is usefull to set width. Assign a string to it and
  //will automatically resize the List so that certain string fits wide
  //ReadOnly property avaiable

  ListO:=TOmegaList.Create(OthersList);         //add the ListBox
  ListO.Image[0]:=ImageList.ImageList.Items[6]; //defaul image
  ListO.ImageIndex[0]:=0;
  ListO.Image[3]:=ImageList.ImageList.Items[7]; //focussed item image
  ListO.ImageIndex[3]:=0;
  ListO.Anim[3]:=True;
  ListO.AnimCount[3]:=2;
  ListO.AnimSpeed[3]:=100;
  ListO.Color[3]:=OmegaColor(255,180,180,120);
  ListO.X:=200;
  ListO.Y:=250;
  ListO.Width:=200;
  ListO.Height:=90;
  ListO.Add('Whatever');        //add some items into listbox
  ListO.Add('Something');
  ListO.Add('Other thing');
  ListO.Sort;                   //and sort them :)
  //Lists have a property call CanSelect that specifies if Items can be selected
  //or only clicked on. Try. Property LinePattern also available
  //To check wether an item is selected, use Selected[index] property
  //To get the string of certain list position use Items[index]
  //Insert, Delete and IndexOf methods also available
  //Border property set the Border width

  TextO:=TOmegaText.Create(OthersList);         //finally add the Text component
  TextO.Image[0]:=ImageList.ImageList.Items[6]; //with just default image
  TextO.ImageIndex[0]:=0;
  TextO.X:=200;
  TextO.Y:=100;
  TextO.Width:=200;
  TextO.Height:=90;
  TextO.NoCarry:=True;                  //when load from file/stream, ignore the
                                        //EOL and carry characters.

  TextO.LoadFromFile('hello.txt');      //Load text from external file
  //Property LinePattern also avaiable
  //You can also load from file/stream lines for ListBox
  //Listboxs are Text-component descendant

  //Let's add an event for you to see how it works
  //We'll add an event for when user clicks on 'button'
  ButtonO[0].OnClick:=Button1Click;
  ButtonO[3].OnClick:=RadioButtonClick;
  ButtonO[4].OnClick:=Button5Click;

  //and now another event for CheckButton, to activate/deactivate Button event
  ButtonO[1].OnClick:=CheckButtonClick;
  ButtonO[1].Active:=True;


//*****************************************************************************
//Sample 2 new code
//*****************************************************************************
  PanelList:=TOmegaGUIPanel.Create(OmegaGUI);
  PanelList.Name:='Panel';

  PanelList.X:=430;
  PanelList.Y:=25;
  PanelList.Width:=200;
  PanelList.Height:=90;
  PanelList.Image:=ImageList.ImageList.Items[6];
  PanelList.ImageIndex:=0;
  PanelList.Caption:='This is my first panel :)';

  //Panels are like any other component list, but this one has Image.
  //You have to add components to Panel as you do with other Lists.
  //When you move the panel, all components owned move too.
  //When you disable the panel, all components owned are disabled
  //When you make panel invisible, so do owned components.
                                                //another major add :)
  ButtonO[1].ChangeList(PanelList);             //let's change from lists

  ButtonO[0].ZTop;                              //takes button0 to the highest Z
  //ZBottom also supported
  //Both work for Component Lists too. the first component list created is has
  //the lowest Z value. You can change this by ZTop, ZBottom.
  //A list with higher Z value than other, draws ALL its component above ALL
  //components in lists with less Z value. Hope you get it :)

  PBarO:=TOmegaBar.Create(OthersList);
  PBarO.Image[0]:=ImageList.ImageList.Items[9];
  PBarO.ImageIndex[0]:=1;
  PBarO.Image[3]:=ImageList.ImageList.Items[9];
  PBarO.ImageIndex[3]:=0;
  PBarO.BlendMode[3]:=1;
  PBarO.X:=25;
  PBarO.Y:=350;
  PBarO.Width:=25;
  PBarO.Height:=200;
  PBarO.Position:=63;
  PBarO.Kind:=bhorizontal;
  PBarO.ShowPos:=True;

  PScrollO:=TOmegaScrollBar.Create(OthersList);
  PScrollO.Image[0]:=ImageList.ImageList.Items[9];
  PScrollO.ImageIndex[0]:=1;
  PScrollO.Image[3]:=ImageList.ImageList.Items[9];
  PScrollO.ImageIndex[3]:=0;
  PScrollO.BlendMode[3]:=1;
  PScrollO.X:=450;
  PScrollO.Y:=200;
  PScrollO.Width:=25;
  PScrollO.Height:=200;
  PScrollO.Position:=0;
  PScrollO.Kind:=bVertical;//Horizontal;
  PScrollO.Min:=2;
  PScrollO.Max:=6;
  PScrollO.Position:=2;

  ButtonO[1].Color[3]:=OmegaColor(255,255,140,200);
  //specify the color for the image :)
  //of course yo don't need to do this for all index of all images
  //if you don't specify, (255,255,255,255) is taken by default

//*****************************************************************************
  //also added OmegaGUI.FocusID property
  //If you want to set focus on any component,
  //set this property to component's ID, like
  //-----------------------------------------
  //-->  OmegaGUI.FocusID:=Component.ID;  <--
  //-----------------------------------------
  //This way you can handle things by keyboard using your own code
  //This is the only way until I make Keyboard support integrated
  //You can also read from FocusID the actual focussed component's ID.

  //by the way, if you Focus on a Button, you can press Return Key instead
  //of clicking on it. Space Key is also supported
  // Of course, you can also do
  //                 *****Button.Activate:=False/True*****
  // !!! Carefull, this doesn't check exclusivity in RadioButtons !!! (yet)
//*****************************************************************************
// and yet another similar property
  //-----------------------------------------
  //-->  OmegaGUI.SelID:=Component.ID;  <--
  //-----------------------------------------
// This is for component selection, I mean, as if mouse was over it (highlight)

  OmegaGUI.Init;                                //ok, you have to Init GUI for
                                                //it to trap windows messages

  //be careful. Image 3, the one for focussed/actived components, draws on top
  //of Image 0,1 or 2. Look at ImageList and you'll understand :)

//********************************
//You can now set background image
//******************************** 
//  OmegaGUI.BackGround:=ImageList.ImageList.Items[10];

  ButtonO[1].X := 500;
  ButtonO[1].Y := 250;
end;

procedure TForm1.TimerTimer(Sender: TObject);
begin
  OmegaScreen.BeginRender;
  ImageList.BeginDraw;
  OmegaScreen.ClearScreen(0,0,0,0);
  OmegaGUI.Draw;                                //draw the GUI images

  Font2.Print(10,410,IntToStr(OmegaGUI.IDCounter-1)+ ' supervised components. FPS =' +
               IntToStr(round(Timer.FPS)));
  ImageList.EndDraw;
 
  OmegaScreen.EndRender;
  Caption:=IntToStr(OmegaGUI.FocusID);
end;

procedure TForm1.Button5Click(Sender:TObject);
begin
  ShowMessage('Button with caption ' + TOmegaButton(Sender).Caption + ' pressed');
  TOmegaButton(Sender).ZTop;   //on top :)
  OmegaGUI.CursorPos(15,15);
end;

procedure TForm1.RadioButtonClick(Sender:TObject);
begin
  TOmegaButton(Sender).ZTop;   //on top, also OnBottom avaible
  OmegaGUI.FocusID:=ButtonO[1].ID;
  ButtonO[0].Active:=True;
end;

procedure TForm1.Button1Click(Sender:TObject);
begin
  ShowMessage('Button clicked :)');
end;

procedure TForm1.CheckButtonClick(Sender:TObject);
begin
  If TOmegaButton(Sender).Active then
    ButtonO[0].OnClick:=nil
  else
    ButtonO[0].OnClick:=Button1Click;
end;

end.
