unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, OmegaTimer, OmegaInput, OmegaImageList, OmegaSprite,
  OmegaScreen, Menus, ExtCtrls, StdCtrls, math, OmegaParticleEngine,
  OmegaBitmapFont, OmegaUtils;

var MyMaxSc, MyMinX, MyMaxX, MyMinY, MyMaxY: single;

type
  TSnowParticle = class(TParticle)
  public
    MinSX, MaxSX, MinSY, MaxSY, MinX, MaxX, MinY, MaxY: single;
    MinWobble, MaxWobble, MinA, MaxA: integer;
    procedure Update(MoveCount: Single); override;
    procedure Reset; override;
  end;

type
  TForm1 = class(TForm)
    OmegaScreen1: TOmegaScreen;
    OmegaSprite1: TOmegaSprite;
    OmegaTimer1: TOmegaTimer;
    OmegaImageList1: TOmegaImageList;
    OmegaParticleEngine1: TOmegaParticleEngine;
    OmegaBitmapFont1: TOmegaBitmapFont;
    inp: TOmegaInput;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure OmegaTimer1Timer(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  end;

var
  LastTick: DWORD;
  Form1: TForm1;
  MaxParticles: integer;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  Randomize;
  self.ClientWidth := 800;
  self.ClientHeight := 600;
  OmegaScreen1.Width := self.ClientWidth;
  OmegaScreen1.Height := self.ClientHeight;
  OmegaScreen1.Init;
  MaxParticles := 300;

  with OmegaParticleEngine1.EngineList.Items[0] do
  begin
    UseCustomParticle(TSnowParticle);
    Sprite.Image := OmegaImageList1.ImageList.Items[0];
    Sprite.ImageIndex := -1;
    Sprite.Red := 255;
    Sprite.Green := 255;
    Sprite.Blue := 255;
    Particle.Decay := 1;
    Particle.LifeTime := 100;
    Particle.RandomLocation := false;
    Particle.Animate := false;
    Particle.Loop := False;
    Particle.RepeatCount := 0;
    Particle.Z := 500;
  end;
  OmegaParticleEngine1.Init;
  MyMinX := 1.6; MyMaxX := 1;
  MyMinY := 1.4; MyMaxY := 1.8;
  MyMaxSc := 0.7;
// OmegaScreen1.SetGamma(255,255,255,150,128);
end;

procedure TForm1.FormShow(Sender: TObject);
begin
 LastTick := GetTickCount;
 OmegaTimer1.Enabled := True;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 OmegaTimer1.Enabled := False;
end;

procedure TForm1.OmegaTimer1Timer(Sender: TObject);
var Tick: DWORD;
begin
 inp.update;
 if oisbutton1 in inp.Keyboard.statesclicked then OmegaScreen1.ToggleFullScreen;
 if not OmegaScreen1.CanDraw then exit;
 Tick := GetTickCount - LastTick;
 LastTick := GetTickCount;
 OmegaParticleEngine1.UpdateAll(Tick * 0.1);
 with OmegaParticleEngine1.Enginelist.Items[0] do
 begin
  while NumOfParticles < MaxParticles do NumOfParticles := NumOfParticles + 1;
  while NumOfParticles > MaxParticles do NumOfParticles := NumOfParticles - 1;
 end;

 OmegaScreen1.BeginRender;
 OmegaScreen1.SetBlendMode(0);
 OmegaImageList1.ImageList.Items[1].Draw(0, 0, 0, 0, 0, 1.25, 1.25,
  OmegaColor($FFFFFFFF), -1);
 OmegaScreen1.SetBlendMode(1);

 OmegaBitmapFont1.Print(50, 30, 'Press "Q" for less snowflakes');
 OmegaBitmapFont1.Print(50, 50, 'Press "W" for more snowflakes');
 OmegaBitmapFont1.Print(50, 70, 'Press "S" for new size');
 OmegaBitmapFont1.Print(50, 90, 'Press "R" for new behaviour');
 OmegaBitmapFont1.Print(50, 110, 'Press "Space" to toggle fullscreen');

 OmegaSprite1.Draw;
 OmegaSprite1.Move(0);
 OmegaSprite1.Dead;
 
 OmegaScreen1.EndRender;
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
end;

{ TSnowParticle }

procedure TSnowParticle.Reset;
begin
 inherited Reset;
 // change these parameters to influence
 // the snowflakes' movement/behaviour/appearance!
 XAcc := 0; YAcc := 0;

 MinX := MyMinX; MaxX := MyMaxX;
 MinY := MyMinY; MaxY := MyMaxY;

// MinX := 1.6; MaxX := 1;
// MinY := 1.4; MaxY := 1.8;
 MinA := 50; MaxA := 255;
 MinSX := 0.2; MaxSX := MyMaxSc;

 XVel := MinX + random * (MaxX - MinX);
 YVel := MinY + random * (MaxY - MinY);
 ScaleX := MinSX + random * (MaxSX - MinSX);
 ScaleY := ScaleX;
 Alpha := MinA + random(MaxA - MinA);

 MinWobble := -5;
 MaxWobble := 5;

 Decay := 0;
 X := random(800);
 Y := random(600);
end;

procedure TSnowParticle.Update(MoveCount: Single);
begin
 inherited Update(MoveCount);
 Z := Z - 1;
 x := x + 0.1 * (MinWobble + random(MaxWobble - MinWobble));
 if x > 810 then begin x := -5; y := random(600) end;
 if x < -10 then begin x := 805; y := random(600) end;
 if y > 610 then begin y := -5; x := random(800) end;
 if y < -10 then begin y := 605; x := random(800) end;
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if ord(key) = 27 then Form1.Close;
  if ord(key) = ord('W') then
   if MaxParticles < 1500 then MaxParticles := MaxParticles + 50;
  if ord(key) = ord('Q') then
   if MaxParticles > 50 then MaxParticles := MaxParticles - 50;
  if ord(key) = ord('R') then
  begin
   MyMinX := random * 4 - 1;
   MyMaxX := random * 8 - 3;
   MyMinY := random * 4 - 1;
   MyMaxY := random * 8 - 3;
   OmegaParticleEngine1.Enginelist.Items[0].NumOfParticles := 0;
  end;
  if ord(key) = ord('S') then
  begin
   MyMaxSc := random * 2;
   OmegaParticleEngine1.Enginelist.Items[0].NumOfParticles := 0;
  end;
end;

end.



