unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, OmegaImageList, OmegaScreen, OmegaTimer,
  OmegaBitmapFont, OmegaUtils, OmegaRenderer, ExtCtrls,
  OmegaSurface, StdCtrls;

type
  TForm1 = class(TForm)
    OmegaScreen1: TOmegaScreen;
    OmegaImageList1: TOmegaImageList;
    OmegaTimer1: TOmegaTimer;
    OmegaBitmapFont1: TOmegaBitmapFont;
    Panel1: TPanel;
    Panel2: TPanel;
    OmegaSurface2: TOmegaSurface;
    OmegaSurface1: TOmegaSurface;
    Label1: TLabel;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure OmegaTimer1Timer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  end;

var Form1: TForm1;
    sc1, sc2, sc3, sc4, angle, ang: single;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
 sc1:=1;sc2:=1;
 randomize;

 OmegaScreen1.Init;
 OmegaScreen1.Width := Panel1.ClientWidth;
 OmegaScreen1.Height := Panel1.ClientHeight;
 OmegaScreen1.SetHWnd(Panel1.handle);
 OmegaSurface1.SethWnd(Panel1.handle);
 OmegaSurface2.Width := Panel2.ClientWidth;
 OmegaSurface2.Height := Panel2.ClientHeight;
 OmegaSurface2.SethWnd(Panel2.handle);
 OmegaScreen1.SetAntiAliasing(true);

 OmegaTimer1.Enabled := True;
end;

procedure TForm1.OmegaTimer1Timer(Sender: TObject);
var s: single;  // sine and cosine variables
begin
 if not omegascreen1.CanDraw then exit;
 OmegaScreen1.BeginRender;

 OmegaScreen1.ClearScreen(0, 0, 0, 0);
 angle := angle + 0.6;
 if angle >= 360 then angle := angle - 360;
 s := sin(angle * pi / 180);

 OmegaImageList1.ImageList.items[0].draw(0,0,s*40,0,0,2,2,
 OmegaColor(round((1-abs(s))*255), round(abs(s)*255), 255, 255),-1);
 OmegaBitmapFont1.Print(60, 10, 'render on main area');

 OmegaSurface1.BeginRender;
 OmegaScreen1.ClearScreen(255,0,0,0);
 OmegaImageList1.ImageList.items[0].draw(
  OmegaSurface1.x + round(s*60),
  OmegaSurface1.y,0,0,0,0.6,0.6,OmegaColor($FFFFFF00),-1);
 OmegaBitmapFont1.Print(OmegaSurface1.x + 20, OmegaSurface1.y,
  'render on surface of main area');
 OmegaSurface1.EndRender;

 OmegaSurface2.BeginRender;
 OmegaScreen1.ClearScreen(0,0,255,0);
 OmegaImageList1.ImageList.items[0].draw(
  -30,-30,s*90,0.5,0.5,0.6,0.6,OmegaColor($FF0FFF90),-1);
 OmegaBitmapFont1.Print(20, 0, 'render on surface');
 OmegaBitmapFont1.Print(20, 20, 'of external area');
 OmegaSurface2.EndRender;

 OmegaScreen1.EndRender;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 OmegaTimer1.Enabled := False;
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if key = 27 then close;
end;

end.
