unit Unit1;
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, OmegaSprite, OmegaSound3D, OmegaMusic, OmegaTimer, OmegaFont,
  OmegaImageList, OmegaScreen;

type
  TPlayer = class(TSprite)   // our player sprite
end;

type
  TForm1 = class(TForm)
    OmegaScreen1: TOmegaScreen;
    OmegaImageList1: TOmegaImageList;
    OmegaFont1: TOmegaFont;
    OmegaTimer1: TOmegaTimer;
    OmegaMusic1: TOmegaMusic;
    OmegaSound3D1: TOmegaSound3D;
    OmegaSprite1: TOmegaSprite;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure OmegaTimer1Timer(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Player : TPlayer;                  // our player sprite
  rot : integer;                     // rotation variable for our electric thing
  Keys: array[0..255] of Boolean;    // our array to see what keys were pressed

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  OmegaScreen1.SethWnd(Form1.Handle);               // this is set to let the graphics know where to render to. Any component with a handle property can be rendered to
  OmegaScreen1.Width:=ClientWidth;
  OmegaScreen1.Height:=ClientHeight;
  OmegaScreen1.Init;                                // MUST be called before doing pretty much anything else :)  This initializes all graphics
  OmegaImageList1.Init;                             // must be called before you do anything with any images

  // try to adjust these if you have texture problems
  // and tell me (tobybear@web.de) what value works best
  // for you!
  OmegaImageList1.TexScaleX := 0.5;
  OmegaImageList1.TexScaleY := 0.5;
  OmegaImageList1.TexOfsX := 0.5;
  OmegaImageList1.TexOfsY := 0.5;


  OmegaFont1.CreateFont('verdana', 10, []);           // creates our font to be used in our game
  OmegaFont1.Color := OmegaColor(255,255,255,255);  // Sets the font color
  OmegaMusic1.Init;                                 // Must be called before using our music component
  OmegaSound3D1.Init;                               //! This call is also new, and needed for the OmegaSound3D component from now on!

  Player := TPlayer.Create(OmegaSprite1);                        // create our player from our TPlayer class
  With Player Do
    begin
      BlendMode := bmNormal;
      X := 10;                                                   // Our player's X position
      Y := 10;                                                   // Our Player's Y position
      CenterX := 0.5;
      CenterY := 0.5;
      Width := OmegaImageList1.ImageList.Items[0].ImageWidth;    // Sets our players width to the width of the image we are going to use
      Height := OmegaImageList1.ImageList.Items[0].ImageHeight;  // Sets our players height to the height of the image we are going to use
      Image := OmegaImageList1.ImageList.Items[0];               // sets our players image to the image in our imagelist
      ImageIndex := -1;                                          // Sets the imageindex to -1 which means we want to use our entire image
    end;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  OmegaTimer1.Enabled := True;                                    // enable our omegaTimer

  OmegaMusic1.Songs.Items[0].Volume := 20;                        // Set the volume down a little
  OmegaMusic1.Songs.Items[0].Loop := true;
  OmegaMusic1.Songs.Items[0].Play;                                // Play our background music

  //! I had to set the Play() method at the bottom since only then the Volume and SoundPosition settings apply
  OmegaSound3D1.SoundList.Items[0].Volume := 100;                 // set its volume
  OmegaSound3d1.SoundList.Items[0].SoundPositionX := 320 / 100;   // set where in the screen our sound comes from.  Must be a small number so just divide what you want by 100
  OmegaSound3d1.SoundList.Items[0].SoundPositionY := 240 / 100;   // same as above
  OmegaSound3D1.SoundList.Items[0].Play;                          // Play our sound effect
end;

procedure TForm1.OmegaTimer1Timer(Sender: TObject);
var a,b : integer;
begin
  if Keys[VK_ESCAPE] then close;
  
  if Keys[VK_LEFT] then
    begin
      Player.X := Player.X - 1.5;
      Player.Rotation := 90;
    end;
  if Keys[VK_RIGHT] then
    begin
      Player.X := Player.X + 1.5;
      Player.Rotation := 270;
    end;
  if Keys[VK_UP] then
    begin
      Player.Y := Player.Y - 1.5;
      Player.Rotation := 180;
    end;
  if Keys[VK_Down] then
    begin
      Player.Y := Player.Y + 1.5;
      Player.Rotation := 0;
    end;

//---------------------------------------------------------------------------//
//              Move Listener to Player's Position                           //
//---------------------------------------------------------------------------//

//  OmegaSound3d1.ListenerPositionX := Player.X / 100;   // makes sure that what we hear is actually near us
  //OmegaSound3d1.ListenerPositionY := Player.Y / 100;

  OmegaScreen1.ClearScreen(0,0,0,0);    // clear the screen
  OmegaScreen1.BeginRender;             // MUST be called before drawing
  OmegaImageList1.BeginDraw;            // Must be called before drawing with imagelist
  for a := 0 to OmegaScreen1.Width div 32 do
    for b := 0 to OmegaScreen1.Height div 32 do
      OmegaImageList1.ImageList.Items[2].Draw(a*32,b*32,0,0,0,1,1,255,255,255,255,false,1);     // draw our map
  Player.Draw;  // draws our player

  OmegaImageList1.ImageList.Items[3].Draw(320,240,rot,0.5,0.5,3,3,
   OmegaColor(random(255),random(255),random(255),250), -1,
   bmSrcAdd); // draws our electric object

  OmegaFont1.Print(10,10,'FPS: '+IntToStr(round(OmegaTimer1.FPS)));  // prints text onto the screen
  OmegaFont1.Print(10,30,'Move closer to the spinning spiral and listen how the sound changes!');
  OmegaImageList1.EndDraw;    // finishes rendering procedure
  OmegaScreen1.EndRender;     // finishes rendering procedure - MUST be called for anything to show on screen
  rot := rot + 2;             // increase our rotation
  OmegaMusic1.Loop;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  Keys[key] := True;
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  Keys[key] := False;
end;

end.
