unit OmegaClass;

interface

uses Controls, Messages;

type
  TWndProcControlClassProc = procedure(var Message: TMessage; DefWindowProc: TWndMethod) of object;

  TWndProcControlClass = class
  private
    FControl: TControl;
    FDefWindowProc: TWndMethod;
    FWindowProc: TWndProcControlClassProc;
    Procedure WndProc(var Message: TMessage);
  public
    Constructor Create(Control: TControl; WindowProc: TWndProcControlClassProc);
    Destructor Destroy;override;
  end;

implementation

Constructor TWndProcControlClass.Create(Control: TControl; WindowProc: TWndProcControlClassProc);
begin
  inherited Create;
  FControl := Control;
  FWindowProc := WindowProc;
  FDefWindowProc := FControl.WindowProc;
  FControl.WindowProc := WndProc;
end;

Procedure TWndProcControlClass.WndProc(var Message: TMessage);
begin
  FWindowProc(Message, FDefWindowProc);
end;

Destructor TWndProcControlClass.Destroy;
begin
  FControl.WindowProc := FDefWindowProc;
  inherited Destroy;
end;

end.
 